---
title: Using the link role
slug: Web/Accessibility/ARIA/ARIA_Techniques/Using_the_link_role
tags:
  - ARIA
  - Accessibility
---
<p class="p1">This technique demonstrates how to use the <a class="external" href="https://www.w3.org/WAI/PF/aria-1.1/roles#link">link</a> role and describes the effect it has on browsers and assistive technology.</p>

<p class="p1">The link role is used to identify an element that creates a hyperlink to a resource that is in the application or external. When this role is added to an element, tab can be used to change focus to the link, and enter used to execute the link.</p>

<div class="note"><strong>Note: </strong>Where possible, it is recommended that you use a native {{HTMLElement("a")}} element rather than the link role, as native elements are more widely supported by older user agents and assistive technology. Native {{HTMLElement("a")}} elements also support keyboard and focus requirements by default, without need for additional customization.</div>

<p class="p1">The <a class="external" href="http://www.w3.org/TR/wai-aria-practices/#focus_tabindex">tabindex</a> attribute may optionally be used with this role to directly specify the position of the element in the tab order.</p>

<h2 id="Possible_effects_on_user_agents_and_assistive_technology">Possible effects on user agents and assistive technology </h2>

<p class="p1">When the link role is added to an element, or such an element becomes visible, the user agent should do the following:</p>

<ul class="ul1">
 <li class="li2">Expose the element as having a link role in the operating system's accessibility API.</li>
 <li class="li2">Fire an accessible link event using the operating system's accessibility API if it supports it.</li>
</ul>

<p class="p1">Assistive technology products should listen for such an event and notify the user accordingly:</p>

<ul class="ul1">
 <li class="li2">Screen readers should announce the text of the link or its label when it is focused, along with the fact that it is a link. ARIA links should be included in the screen reader's “List Links” function just like ordinary links, and actions in this dialogue list, such as “Activate Link” or “Move to Link”, should perform the same as they do with ordinary links. </li>
 <li class="li2">Screen magnifiers may enlarge links.</li>
</ul>

<div class="notecard note">
<p><strong>Note:</strong> Opinons may differ on how assistive technology should handle this technique. The information provided above is one of those opinions and therefore not normative.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>This example shows how to implement a fake link using a <code>&lt;span&gt;</code> element. This includes JavaScript to grab the location and handle navigating to the new location using <code>window.open()</code> via clicking, and using keyboard, CSS to give the desired visuals of a link, the <code>tabindex="0"</code> attribute to make it keyboard-focussable, and <code>role="link"</code> to make it recognised as a link by assistive technology.</p>

<p>This is a huge amount of work just to recreate something you've get for free using the <code>&lt;a&gt;</code> element, so you should really use that if possible. But this shows that it can be done.</p>

<p>You should however note that there are still problems with this approach:</p>

<ul>
 <li>It is very difficult to detect whether the target of the fake link has been visited before, and therefore use <code>:visited</code> styles (e.g. the default purple color for visited links).</li>
 <li>Opening a page using the <code>open()</code> method counts as being a popup, and certain browsers may issue a warning when you try to activate it, or make you explicitly agree to allowing popups form the domain it exists on.</li>
</ul>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;h1&gt;role="link" example&lt;/h1&gt;

&lt;span data-href="https://mozilla.org" tabindex="0" id="link1" role="link" class="link"&gt;
  Fake accessible link created using a span
&lt;/span&gt;

&lt;p&gt;&lt;a href="https://mozilla.org" target="_blank"&gt;Actual real link&lt;/a&gt;&lt;/p&gt;
</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css">span[role="link"] {
  color: blue;
  text-decoration: underline;
  cursor: pointer;
}

span[role="link"]:focus {
  outline: 1px dotted black;
}</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">const spanElem = document.querySelector('span');

//handles clicks and keydowns on the link
function navigateLink(e) {
    if (e.type === 'click' || e.key === 'Enter') {
        let ref = e.target != null ? e.target : e.srcElement;
        if (ref) {
          window.open(ref.getAttribute('data-href'), '_blank');
        }
    }
}

spanElem.addEventListener('click', navigateLink);
spanElem.addEventListener('keydown', navigateLink);</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Examples', '100%', 160)}}</p>

<h3 id="Notes">Notes </h3>

<p class="p1">If pressing the link triggers an action but does not change browser focus or navigate to a new page, you might wish to consider using the <a class="external" href="http://www.w3.org/TR/wai-aria/roles#button">button</a> role instead of the link role.</p>

<h2 class="p1" id="ARIA_attributes_used">ARIA attributes used</h2>

<ul class="ul1">
 <li class="li2"><a class="external" href="http://www.w3.org/TR/wai-aria/#link">link</a></li>
</ul>

<h2 class="p1" id="Related_ARIA_techniques">Related ARIA techniques </h2>

<ul class="ul1">
 <li class="li2"><a class="external" href="https://www.w3.org/TR/wai-aria/#button">button</a> role</li>
</ul>

<h2 id="Additional_resources">Additional resources</h2>

<ul>
 <li>
  <p class="p1">ARIA Best Practices - Link Role: <a class="external" href="http://www.w3.org/TR/wai-aria-practices/#link">http://www.w3.org/TR/wai-aria-practices/#link</a></p>
 </li>
</ul>
